twidenash = {
    init: function() {
        if (!twidenash.hashtag) return;
        // request hashtag search values for both twitter and identica
        twidenash.callbacks = 0;
        twidenash.items = [];
        twidenash.add_script("http://search.twitter.com/search.json?" +
           "callback=twidenash.cb&rpp=10&q=%23" + twidenash.hashtag);
        twidenash.add_script("http://identi.ca/api/search.json?" +
           "callback=twidenash.cb&rpp=10&q=%23" + twidenash.hashtag);
        twidenash.printed = 0;
    },
    add_script: function(url) {
        var scr = document.createElement("script");
        scr.src = url;
        document.getElementsByTagName("head")[0].appendChild(scr);
    },
    cb: function(data) {
        for (var i=0; i<data.results.length; i++) {
            var dupe = false;
            for (var j=0; j<twidenash.items.length; j++) {
                if (data.results[i].text == twidenash.items[j].text) {
                    dupe = true;
                    break;
                }
            }
            if (dupe) continue;
            twidenash.items.push({ text: data.results[i].text, 
                img: data.results[i].profile_image_url, 
                dt: Date.parse(data.results[i].created_at),
                user: data.results[i].from_user })
        }
        twidenash.callbacks += 1;
        if (twidenash.callbacks == 2) {
            twidenash.items.sort(function(a,b) { return b.dt - a.dt });
            var ul = document.createElement("ul");
            ul.className = "twidenash";
            for (i=0; i<twidenash.items.length && twidenash.printed < 5; i++) {
                var li = document.createElement("li");
                var img = document.createElement("img");
                img.src = twidenash.items[i].img;
                var span = document.createElement("span");
                span.className = 'comment';
                var nick = document.createElement("span");
                nick.className = 'nick';
                nick.appendChild(document.createTextNode(twidenash.items[i].user + 
                    ": "));
                var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i;
                span.innerHTML = twidenash.items[i].text.replace(exp,"<a href='$1' target='_blank'>$1</a>");
                li.appendChild(img);
                li.appendChild(nick);
                li.appendChild(span);
                ul.appendChild(li);
                twidenash.printed++;
            }
            twidenash.scriptelement.parentNode.insertBefore(ul, twidenash.scriptelement);
        }
    },
    cache_scriptname: function() {
        // called before page load so we can find our own name
        var scr = document.getElementsByTagName("script");
        var url = scr[scr.length-1].getAttribute("src");
        if (!url) {
            var twidenash_script = document.getElementById("twidenash_script");
            if (twidenash_script) url = twidenash_script.getAttribute("src");
        }
        if (url && url.lastIndexOf('?') != -1) {
            twidenash.hashtag = url.substr(url.lastIndexOf('?')+1);
            if (twidenash_script) {
                twidenash.scriptelement = twidenash_script;
            } else {
                twidenash.scriptelement = scr[scr.length-1];
            }
        }
    }
};
(function(i) {var u =navigator.userAgent;var e=/*@cc_on!@*/false; var st = 
setTimeout;if(/webkit/i.test(u)){st(function(){var dr=document.readyState;
if(dr=="loaded"||dr=="complete"){i()}else{st(arguments.callee,10);}},10);}
else if((/mozilla/i.test(u)&&!/(compati)/.test(u)) || (/opera/i.test(u))){
document.addEventListener("DOMContentLoaded",i,false); } else if(e){     (
function(){var t=document.createElement('doc:rdy');try{t.doScroll('left');
i();t=null;}catch(e){st(arguments.callee,0);}})();}else{window.onload=i;}})(twidenash.init);
twidenash.cache_scriptname();

